#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

bool curState = HIGH;
bool prevState = HIGH;

// Hello World Program
byte BUTTON_PIN = 13;
byte LOCK_PIN = 12;

byte A[] = {8, 9, 10, 11};
byte Q[] = {5, 4, 3, 2};
byte D[] = {1, 1, 1, 1};

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  Serial.println("Hello World");
  //pinMode(BUTTON_PIN, INPUT_PULLUP);
  pinMode(LOCK_PIN, OUTPUT);

  // SSD1306_SWITCHCAPVCC = generate display voltage from 3.3V internally
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3D)) { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;); // Don't proceed, loop forever
  }
  display.setRotation(3);
  // Clear the buffer
  display.clearDisplay();
display.setTextSize(1);      // Normal 1:1 pixel scale
  display.setTextColor(SSD1306_WHITE); // Draw white text
  display.setCursor(0, 0);     // Start at top-left corner
  display.cp437(true);         // Use full 256 char 'Code Page 437' font
display.println("RAMSim v.1");  
display.display();
  delay(2000);
display.clearDisplay();
}

void loop() {
  // put your main code here, to run repeatedly:
  curState = digitalRead(BUTTON_PIN);
  if(curState == HIGH && prevState == LOW){
	digitalWrite(LOCK_PIN, HIGH);
	Serial.println("-----------***********");
	display.clearDisplay();
display.setTextSize(1);      // Normal 1:1 pixel scale
  display.setTextColor(SSD1306_WHITE); // Draw white text
  display.setCursor(0, 0);     // Start at top-left corner
  display.cp437(true);         // Use full 256 char 'Code Page 437' font
	for (uint8_t i = 0; i <= 15; i++) {  // Цикл от 0 до 15
	    // Разбиваем число на отдельные биты
	    uint8_t bit0 = bitRead(i, 0);  // Младший бит (2^0)
	    uint8_t bit1 = bitRead(i, 1);  // (2^1)
	    uint8_t bit2 = bitRead(i, 2);  // (2^2)
	    uint8_t bit3 = bitRead(i, 3);  // Старший бит (2^3)
		digitalWrite(A[0], bit0);
    	digitalWrite(A[1], bit1);
    	digitalWrite(A[2], bit2);
    	digitalWrite(A[3], bit3);
      display.setTextColor(SSD1306_BLACK, SSD1306_WHITE);
		display.print(bit3);
		display.print(bit2);
		display.print(bit1);        
		display.print(bit0);
		display.setTextColor(SSD1306_WHITE);
        display.print(" ");
		for(int i = 0; i < sizeof(D); i++){
		  D[i] = digitalRead(Q[i]);
		  Serial.print(D[i]);
		  display.print(D[i]);
		}
		
		display.println();
    	Serial.println();
		display.display();
		delay(15);
	  }
    
    digitalWrite(LOCK_PIN, LOW);
  }else{
    digitalWrite(A[0], LOW);
    digitalWrite(A[1], LOW);
    digitalWrite(A[2], LOW);
    digitalWrite(A[3], LOW);
  }
prevState = curState;
}